=== tests/pp/Makefile ===
#
# credits: 01..13.c from the pcc cpp-tests suite
#

TCC = ../../tcc
TESTS = $(patsubst %.c,%.test,$(wildcard *.c))

all test : $(TESTS)

%.test: %.c %.expect
	@echo PPTest $* ...
	@$(TCC) -E -P $< >$*.output 2>&1 ; \
	    diff -Nu -b -B -I "^#" $(EXTRA_DIFF_OPTS) $*.expect $*.output \
	    && rm -f $*.output

# automatically generate .expect files with gcc:
%.expect :
	gcc -E -P $*.c >$*.expect 2>&1

# tell make not to delete
.PRECIOUS: %.expect

clean:
	rm -vf *.output

# 02.test : EXTRA_DIFF_OPTS = -w
# 03.test : EXTRA_DIFF_OPTS = -w
# 04.test : EXTRA_DIFF_OPTS = -w
# 10.test : EXTRA_DIFF_OPTS = -w

# diff options:
# -b ighore space changes
# -w ighore all whitespace
# -B ignore blank lines
# -I <RE> ignore lines matching RE
