=== debian/changelog ===
tcc (0.9.27~git20151227.933c223-1) unstable; urgency=medium

  * New upstream snapshot.
  * Skip tests exected to fail on ARM.

 -- Thomas Preud'homme <robotux@debian.org>  Sun, 27 Dec 2015 13:10:43 +0800

tcc (0.9.27~git20151225.f15c0a9-1) unstable; urgency=medium

  * New upstream snapshot (Closes: #808008).

 -- Thomas Preud'homme <robotux@debian.org>  Sat, 26 Dec 2015 18:42:39 +0800
